// Copyright 2023 The Inspektor Gadget authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package columns

import (
	"reflect"
)

// DynamicField manually describes fields this library should be able to access. Combined with the DynamicPtr
// interface, this can be used to access fields for example in a byte slice. Either Attributes or a Tag has
// to be set - if both are set, Tag takes precedence over the Attributes.
type DynamicField struct {
	Attributes *Attributes
	Tag        string
	Template   string
	Type       reflect.Type
	Offset     uintptr
}
